<script setup lang="ts">
  const props = withDefaults(
    defineProps<{
      disabled?: boolean;
      hightestScore?: number;
      modelValue?: number;
      size?: 'small' | 'medium';
    }>(),
    {
      modelValue: 0,
      hightestScore: 5,
      size: 'medium',
    },
  );

  const emits = defineEmits(['update:modelValue', 'change']);

  const isHoverActive = ref(false);
  const hoveredIndex = ref<number | undefined>(0);

  const displayedScore = computed(
    () => (isHoverActive.value ? hoveredIndex.value : props.modelValue) ?? 0,
  );

  const handleMouseLeave = () => {
    if (props.disabled) return;
    isHoverActive.value = false;
  };

  const handleHover = (key: number) => {
    if (props.disabled) return;
    hoveredIndex.value = key;
    isHoverActive.value = true;
  };

  const handleChangeRating = (i: number) => {
    if (props.disabled) return;
    emits('update:modelValue', i);
    emits('change', i);
  };
</script>
<template>
  <span
    v-for="i in hightestScore"
    :key="i"
    class="shrink-0 grow-0 text-yellow-900"
    :class="{
      'i-sw-solid:star': displayedScore >= i,
      'i-sw-regular:star': displayedScore < i,
      'cursor-pointer': !props.disabled,
      'h-4 w-4': props.size === 'small',
      'mr-1 h-5 w-5': props.size === 'medium',
    }"
    @mouseleave="handleMouseLeave"
    @mouseover="handleHover(i)"
    @click="handleChangeRating(i)"
  />
</template>
